using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using RemotingExample.BusinessFacade;

namespace RemotingExample.WebCl
{
	/// <summary>
	/// Summary description for WebForm1.
	/// </summary>
	public class WebForm1 : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.TextBox tbText;
		protected System.Web.UI.WebControls.Button btnPrintInfo;
		protected System.Web.UI.WebControls.Label lbDisplay;
		protected System.Web.UI.WebControls.Button btnLogout;
		protected System.Web.UI.WebControls.DataGrid dgSession;
		protected System.Web.UI.WebControls.Label lbStatus;
		protected System.Web.UI.WebControls.Label Label1;
		protected System.Web.UI.WebControls.Label Label2;
		protected System.Web.UI.WebControls.Label Label3;
		protected System.Web.UI.WebControls.Label Label4;
		protected System.Web.UI.WebControls.Button Button1;
		protected System.Web.UI.WebControls.TextBox tbKey;
		protected System.Web.UI.WebControls.TextBox tbValue;
		protected System.Web.UI.WebControls.RequiredFieldValidator rfvKey;
		protected System.Web.UI.WebControls.RequiredFieldValidator rfvValue;
		protected System.Web.UI.WebControls.HyperLink HyperLink1;
		protected System.Web.UI.WebControls.Button btnAdminWork;
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			
			lbDisplay.BackColor = System.Drawing.Color.Green;
			lbDisplay.Text = "";
			rfvKey.Enabled = false;
			rfvValue.Enabled = false;

			if (!IsPostBack)
			{
				if (User.IsInRole("admin"))
				{
					lbStatus.Text = "Current role : Adminitrator." ;
				}
				else
				{
					lbStatus.Text = "Current role : User.";

				}
				lbStatus.Text += " Login: " + RemotingExample.Security.ClientSecurityContext.Current.Login ;
				BindDgSession();
			}

		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.btnAdminWork.Click += new System.EventHandler(this.btnAdminWork_Click);
			this.btnPrintInfo.Click += new System.EventHandler(this.btnPrintInfo_Click);
			this.btnLogout.Click += new System.EventHandler(this.btnLogout_Click);
			this.Button1.Click += new System.EventHandler(this.Button1_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		
		private void btnAdminWork_Click(object sender, System.EventArgs e)
		{
			try
			{
				(new RemotingExample.BusinessFacade.SomeSystem()).DoAdminWork(this.tbText.Text);
			}
			catch (System.Security.SecurityException ex)
			{
				DisplayError("You don't have permission for this method call<br>Server response: "+ex.Message);
				return;
			}
			DisplayInfo("Admin's work successfully done! Message sent!");

		}
		
		private void DisplayError(string text)
		{
			lbDisplay.BackColor = System.Drawing.Color.Red;
			lbDisplay.Text = text;
			
		}

		private void DisplayInfo(string text)
		{
			lbDisplay.BackColor = System.Drawing.Color.Green;
			lbDisplay.Text = text;
		}


		private void btnPrintInfo_Click(object sender, System.EventArgs e)
		{
			string text  = (new RemotingExample.BusinessFacade.SomeSystem()).PrintUserInfo();
			text = text.Replace(Environment.NewLine,"<br>");
			DisplayInfo(text);
		}

		private void btnLogout_Click(object sender, System.EventArgs e)
		{
			Response.Redirect("logout.aspx",true);
		}

		private void Button1_Click(object sender, System.EventArgs e)
		{
			rfvKey.Enabled = true;
			rfvValue.Enabled = true;
			rfvKey.Validate();
			rfvValue.Validate();
			if ((rfvKey.IsValid)&&(rfvValue.IsValid))
			{
				if (RemotingExample.Security.ClientSecurityContext.Current.Items.Contains(tbKey.Text))
				{
					DisplayError("Key: '"+tbKey.Text+"' already exists in  RemotingExample.Security.ClientSecurityContext.Current.Items");
					return;
				}
				RemotingExample.Security.ClientSecurityContext.Current.Items.Add(tbKey.Text,tbValue.Text);				
				BindDgSession();
			}
			
		}

		private void BindDgSession()
		{
			dgSession.DataSource = RemotingExample.Security.ClientSecurityContext.Current.Items;
			dgSession.DataBind();		
		}
	}
}
