using System;
using System.Collections;
using System.ComponentModel;
using System.Web;
using System.Web.SessionState;
using System.Security.Principal;
using System.Runtime.Remoting;
using RemotingExample.Security;
using System.Web.Security;

namespace RemotingExample.WebCl
{
	/// <summary>
	/// Summary description for Global.
	/// </summary>
	public class Global : System.Web.HttpApplication
	{
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.IContainer components = null;

		public Global()
		{
			InitializeComponent();
		}	
		
		protected void Application_Start(Object sender, EventArgs e)
		{
			//Start remoting configuration
			string configPath = System.IO.Path.Combine(Context.Server.MapPath( Context.Request.ApplicationPath ),"Web.config");
			RemotingConfiguration.Configure(configPath);
		}
 
		protected void Session_Start(Object sender, EventArgs e)
		{

		}

		protected void Application_BeginRequest(Object sender, EventArgs e)
		{

		}

		protected void Application_EndRequest(Object sender, EventArgs e)
		{

		}

		protected void Application_AuthenticateRequest(Object sender, EventArgs e)
		{
			//Authenticate request.
			if (Context.Request.IsAuthenticated == true)
			{
					
				string cookieName = FormsAuthentication.FormsCookieName;
				HttpCookie authCookie = Context.Request.Cookies[cookieName];
				System.Web.Security.FormsAuthenticationTicket authTicket = null;
					
				try
				{
					authTicket = System.Web.Security.FormsAuthentication.Decrypt(authCookie.Value);
				}
				catch(Exception)
				{
					return;
				}

				if (null == authTicket)
				{
					return; 
				} 
				//Get session ID from userData   authentication tiket field 
				string sessionID = authTicket.UserData;
				
				ClientSecurityContext securityContext = null;
				//Get ClientContext from SecurityContextContainer
				
					securityContext = (ClientSecurityContext)SecurityContextContainer.GetInstance()[sessionID];
				
				
				
				
				if (securityContext != null)
				{
					ClientSecurityContext.Current = securityContext;
					//attach userPrincipal to current thread
					Context.User = securityContext.User;
				}
				else
				{
					System.Web.Security.FormsAuthentication.SignOut();
					Response.Redirect("logout.aspx");
				}
				
			}
		}

		protected void Application_Error(Object sender, EventArgs e)
		{
			Exception ex = Server.GetLastError();
			if (ex is System.Security.SecurityException)
			{
				Server.ClearError();
				Response.Redirect("logout.aspx",true);
				return;
			}
		}

		protected void Session_End(Object sender, EventArgs e)
		{

		}

		protected void Application_End(Object sender, EventArgs e)
		{

		}
			
		#region Web Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.components = new System.ComponentModel.Container();
		}
		#endregion
	}
}

