using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using RemotingExample.BusinessFacade;
using RemotingExample.Security;
using System.Web.Security;

namespace RemotingExample.WebCl
{
	
	public class Login : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.TextBox tbName;
		protected System.Web.UI.WebControls.Label lblMessage;
		protected System.Web.UI.WebControls.TextBox tbPpassword;
		protected System.Web.UI.WebControls.Button btnSubmit;
		protected System.Web.UI.WebControls.RequiredFieldValidator rvdName;
		protected System.Web.UI.WebControls.RequiredFieldValidator rvdPassword;
		protected System.Web.UI.WebControls.Panel pnChangePasswordValidators;
		protected System.Web.UI.WebControls.Label lbActionMessage;
		protected System.Web.UI.HtmlControls.HtmlTableRow rwBtnSubmit;
		protected System.Web.UI.WebControls.Label Label1;
		protected System.Web.UI.WebControls.TextBox tbPassword;
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			
			
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.btnSubmit.Click += new System.EventHandler(this.btnSubmit_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void btnSubmit_Click(object sender, System.EventArgs e)
		{
			
			
			if (IsValid) 
			{
				//The user data. Name, Login ...etc.
				string userData;
				//Prepare user's credentials for authentication  at Remoting chanelsinck
				ClientSecurityContext context = new ClientSecurityContext(tbName.Text,tbPassword.Text);
				
				try 
				{
					//try to get user info
					userData = (new RemotingExample.BusinessFacade.SomeSystem()).GetUserData();
				}
				catch (System.Security.SecurityException ex)
				{
					//Authentication failed
					this.lblMessage.Text = ex.Message;
					return;
				}
				
				//Authentication OK
				//Set forms authentication tiket with 
				SetAuthTiket(tbName.Text, context.SessionID);
		
			}
		
		}

		
		private void SetAuthTiket(string name, string SID)
		{
			//Save user's name and session ID to auth tiket
			FormsAuthenticationTicket authTicket = new  FormsAuthenticationTicket(1,                          // 
				name,           
				DateTime.Now,               
				DateTime.Now.AddMinutes(SecurityContextContainer.GetInstance().SessionTimeOut),
				false,                      
				SID);                    
				
			string encryptedTicket = FormsAuthentication.Encrypt(authTicket);
				
			HttpCookie authCookie = new HttpCookie(FormsAuthentication.FormsCookieName,
				encryptedTicket);
			Response.Cookies.Add(authCookie);
			Response.Redirect("default.aspx");
		}
	}
}
